include:
  - project: "empaia/integration/ci-templates"
    ref: "main"
    file:
      - "pipeline-templates/pipeline-poetry-standard.yml"
      - "job-templates/docker-init.yml"
      - "job-templates/poetry-codecheck.yml"
      - "job-templates/check-existing-docker.yml"
      - "job-templates/docker-build-and-push.yml"

variables:
  TITLE: "MPS"
  DESCRIPTION: "Marketplace Service"
  DIRECTORY: "marketplace_service"
  TEST_DIRECTORY: "tests"
  RUNNER_TAG: "empaia-parallel"
  RUNNER_DOCKER_TAG: "empaia-docker"
  HOST_PORT: 8000
  CONTAINER_PORT: 8000
  DOCKER_RUN_ALIVE_TEST: "false"
  DOCKER_COMPOSE_ALIVE_TEST: "false"
  POETRY_PYTEST: "false"

poetry-codecheck-tests:
  extends: .poetry-codecheck
  variables:
    DIRECTORY: "tests"

poetry-codecheck-tests-auth:
  extends: .poetry-codecheck
  variables:
    DIRECTORY: "tests_auth"

check-existing-docker:
  extends: .check-existing-docker
  variables:
    IMAGE_NAME: $INTERNAL_REGISTRY_URL/empaia/marketplace-service
  needs:
    - job: poetry-get-version
      artifacts: true

docker-based-pytest:
  extends: .docker-init
  tags:
    - empaia-docker
  before_script:
    - !reference [.docker-init, before_script]
    - cp sample_ci.env .env
    - docker compose pull
    - docker compose up --build -d
    - poetry install
    - sleep 30
  script:
    - poetry run pytest tests --maxfail=1
  after_script:
    - docker compose down -v
    - !reference [.docker-init, after_script]

docker-based-pytest-auth:
  extends: .docker-init
  tags:
    - empaia-docker
  before_script:
    - !reference [.docker-init, before_script]
    - cp sample_auth.env .env
    - docker compose up --build -d
    - poetry install
    - sleep 10
  script:
    - poetry run pytest tests_auth --maxfail=1
  after_script:
    - docker compose down -v
    - !reference [.docker-init, after_script]

docker-build-and-push:
  extends: .docker-build-and-push
  variables:
    IMAGE_NAME: $INTERNAL_REGISTRY_URL/empaia/marketplace-service
  needs:
    - !reference [.docker-build-and-push-default-needs, needs]
    - job: docker-based-pytest
    - job: docker-based-pytest-auth
    - job: poetry-codecheck-tests
    - job: poetry-codecheck-tests-auth
  
